<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="de">
<head>
<!-- Generated by javadoc -->
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>DefaultExpressionEngine (Apache Commons Configuration 2.2 API)</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DefaultExpressionEngine (Apache Commons Configuration 2.2 API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/DefaultExpressionEngine.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/tree/DefaultConfigurationKey.KeyIterator.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/tree/DefaultExpressionEngine.html" target="_top">Frames</a></li>
<li><a href="DefaultExpressionEngine.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.apache.commons.configuration2.tree</div>
<h2 title="Class DefaultExpressionEngine" class="title">Class DefaultExpressionEngine</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.apache.commons.configuration2.tree.DefaultExpressionEngine</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">DefaultExpressionEngine</span>
extends <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></pre>
<div class="block"><p>
 A default implementation of the <code>ExpressionEngine</code> interface
 providing the &quot;native&quot; expression language for hierarchical
 configurations.
 </p>
 <p>
 This class implements a rather simple expression language for navigating
 through a hierarchy of configuration nodes. It supports the following
 operations:
 </p>
 <ul>
 <li>Navigating from a node to one of its children using the child node
 delimiter, which is by the default a dot (&quot;.&quot;).</li>
 <li>Navigating from a node to one of its attributes using the attribute node
 delimiter, which by default follows the XPATH like syntax
 <code>[@&lt;attributeName&gt;]</code>.</li>
 <li>If there are multiple child or attribute nodes with the same name, a
 specific node can be selected using a numerical index. By default indices are
 written in parenthesis.</li>
 </ul>
 <p>
 As an example consider the following XML document:
 </p>

 <pre>
  &lt;database&gt;
    &lt;tables&gt;
      &lt;table type=&quot;system&quot;&gt;
        &lt;name&gt;users&lt;/name&gt;
        &lt;fields&gt;
          &lt;field&gt;
            &lt;name&gt;lid&lt;/name&gt;
            &lt;type&gt;long&lt;/name&gt;
          &lt;/field&gt;
          &lt;field&gt;
            &lt;name&gt;usrName&lt;/name&gt;
            &lt;type&gt;java.lang.String&lt;/type&gt;
          &lt;/field&gt;
         ...
        &lt;/fields&gt;
      &lt;/table&gt;
      &lt;table&gt;
        &lt;name&gt;documents&lt;/name&gt;
        &lt;fields&gt;
          &lt;field&gt;
            &lt;name&gt;docid&lt;/name&gt;
            &lt;type&gt;long&lt;/type&gt;
          &lt;/field&gt;
          ...
        &lt;/fields&gt;
      &lt;/table&gt;
      ...
    &lt;/tables&gt;
  &lt;/database&gt;
 </pre>

 <p>
 If this document is parsed and stored in a hierarchical configuration object,
 for instance the key <code>tables.table(0).name</code> can be used to find
 out the name of the first table. In opposite <code>tables.table.name</code>
 would return a collection with the names of all available tables. Similarly
 the key <code>tables.table(1).fields.field.name</code> returns a collection
 with the names of all fields of the second table. If another index is added
 after the <code>field</code> element, a single field can be accessed:
 <code>tables.table(1).fields.field(0).name</code>. The key
 <code>tables.table(0)[@type]</code> would select the type attribute of the
 first table.
 </p>
 <p>
 This example works with the default values for delimiters and index markers.
 It is also possible to set custom values for these properties so that you can
 adapt a <code>DefaultExpressionEngine</code> to your personal needs.
 </p>
 <p>
 The concrete symbols used by an instance are determined by a
 <a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree"><code>DefaultExpressionEngineSymbols</code></a> object passed to the constructor.
 By providing a custom symbols object the syntax for querying properties in
 a hierarchical configuration can be altered.
 </p>
 <p>
 Instances of this class are thread-safe and can be shared between multiple
 hierarchical configuration objects.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>1.3</dd>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>$Id: DefaultExpressionEngine.java 1790899 2017-04-10 21:56:46Z ggregory $</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a
 href="http://commons.apache.org/configuration/team-list.html">Commons
 Configuration team</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static <a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngine</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#INSTANCE">INSTANCE</a></span></code>
<div class="block">A default instance of this class that is used as expression engine for
 hierarchical configurations per default.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#DefaultExpressionEngine-org.apache.commons.configuration2.tree.DefaultExpressionEngineSymbols-">DefaultExpressionEngine</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngineSymbols</a>&nbsp;syms)</code>
<div class="block">Creates a new instance of <code>DefaultExpressionEngine</code> and initializes
 its symbols.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#DefaultExpressionEngine-org.apache.commons.configuration2.tree.DefaultExpressionEngineSymbols-org.apache.commons.configuration2.tree.NodeMatcher-">DefaultExpressionEngine</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngineSymbols</a>&nbsp;syms,
                       <a href="../../../../../org/apache/commons/configuration2/tree/NodeMatcher.html" title="interface in org.apache.commons.configuration2.tree">NodeMatcher</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;nodeNameMatcher)</code>
<div class="block">Creates a new instance of <code>DefaultExpressionEngine</code> and initializes
 its symbols and the matcher for comparing node names.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#attributeKey-java.lang.String-java.lang.String-">attributeKey</a></span>(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
            <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeName)</code>
<div class="block">Returns the key of an attribute.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#canonicalKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">canonicalKey</a></span>(T&nbsp;node,
            <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
            <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Determines a &quot;canonical&quot; key for the specified node in the
 expression language supported by this implementation.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>protected &lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#findLastPathNode-org.apache.commons.configuration2.tree.DefaultConfigurationKey.KeyIterator-T-org.apache.commons.configuration2.tree.NodeHandler-">findLastPathNode</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/DefaultConfigurationKey.KeyIterator.html" title="class in org.apache.commons.configuration2.tree">DefaultConfigurationKey.KeyIterator</a>&nbsp;keyIt,
                T&nbsp;node,
                <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Finds the last existing node for an add operation.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>protected &lt;T&gt;&nbsp;void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#findNodesForKey-org.apache.commons.configuration2.tree.DefaultConfigurationKey.KeyIterator-T-java.util.Collection-org.apache.commons.configuration2.tree.NodeHandler-">findNodesForKey</a></span>(<a href="../../../../../org/apache/commons/configuration2/tree/DefaultConfigurationKey.KeyIterator.html" title="class in org.apache.commons.configuration2.tree">DefaultConfigurationKey.KeyIterator</a>&nbsp;keyPart,
               T&nbsp;node,
               <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;T&gt;&gt;&nbsp;results,
               <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Recursive helper method for evaluating a key.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngineSymbols</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#getSymbols--">getSymbols</a></span>()</code>
<div class="block">Returns the <code>DefaultExpressionEngineSymbols</code> object associated with
 this instance.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#nodeKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">nodeKey</a></span>(T&nbsp;node,
       <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
       <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Returns the key for the specified node in the expression language
 supported by an implementation.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/NodeAddData.html" title="class in org.apache.commons.configuration2.tree">NodeAddData</a>&lt;T&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#prepareAdd-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">prepareAdd</a></span>(T&nbsp;root,
          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
          <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">
 Prepares Adding the property with the specified key.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;T&gt;&gt;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html#query-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">query</a></span>(T&nbsp;root,
     <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
     <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</code>
<div class="block">Finds the nodes and/or attributes that are matched by the specified key.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="INSTANCE">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>INSTANCE</h4>
<pre>public static final&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngine.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngine</a> INSTANCE</pre>
<div class="block">A default instance of this class that is used as expression engine for
 hierarchical configurations per default.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="DefaultExpressionEngine-org.apache.commons.configuration2.tree.DefaultExpressionEngineSymbols-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DefaultExpressionEngine</h4>
<pre>public&nbsp;DefaultExpressionEngine(<a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngineSymbols</a>&nbsp;syms)</pre>
<div class="block">Creates a new instance of <code>DefaultExpressionEngine</code> and initializes
 its symbols.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>syms</code> - the object with the symbols (must not be <b>null</b>)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the symbols are <b>null</b></dd>
</dl>
</li>
</ul>
<a name="DefaultExpressionEngine-org.apache.commons.configuration2.tree.DefaultExpressionEngineSymbols-org.apache.commons.configuration2.tree.NodeMatcher-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>DefaultExpressionEngine</h4>
<pre>public&nbsp;DefaultExpressionEngine(<a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngineSymbols</a>&nbsp;syms,
                               <a href="../../../../../org/apache/commons/configuration2/tree/NodeMatcher.html" title="interface in org.apache.commons.configuration2.tree">NodeMatcher</a>&lt;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&gt;&nbsp;nodeNameMatcher)</pre>
<div class="block">Creates a new instance of <code>DefaultExpressionEngine</code> and initializes
 its symbols and the matcher for comparing node names. The passed in
 matcher is always used when the names of nodes have to be matched against
 parts of configuration keys.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>syms</code> - the object with the symbols (must not be <b>null</b>)</dd>
<dd><code>nodeNameMatcher</code> - the matcher for node names; can be <b>null</b>,
        then a default matcher is used</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="http://docs.oracle.com/javase/7/docs/api/java/lang/IllegalArgumentException.html?is-external=true" title="class or interface in java.lang">IllegalArgumentException</a></code> - if the symbols are <b>null</b></dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getSymbols--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSymbols</h4>
<pre>public&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree">DefaultExpressionEngineSymbols</a>&nbsp;getSymbols()</pre>
<div class="block">Returns the <code>DefaultExpressionEngineSymbols</code> object associated with
 this instance.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the <code>DefaultExpressionEngineSymbols</code> used by this engine</dd>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>2.0</dd>
</dl>
</li>
</ul>
<a name="query-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="query-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>query</h4>
<pre>public&nbsp;&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/util/List.html?is-external=true" title="class or interface in java.util">List</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;T&gt;&gt;&nbsp;query(T&nbsp;root,
                                      <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                      <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Finds the nodes and/or attributes that are matched by the specified key.
 This is the main method for interpreting property keys. An implementation
 must traverse the given root node and its children to find all results
 that are matched by the given key. If the key is not correct in the
 syntax provided by that implementation, it is free to throw a (runtime)
 exception indicating this error condition. The passed in
 <code>NodeHandler</code> can be used to gather the required information from
 the node object. This method supports the syntax as described in the class
 comment.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#query-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">query</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the root node of a hierarchy of nodes</dd>
<dd><code>key</code> - the key to be evaluated</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a list with the results that are matched by the key (should never
         be <b>null</b>)</dd>
</dl>
</li>
</ul>
<a name="nodeKey-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="nodeKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>nodeKey</h4>
<pre>public&nbsp;&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;nodeKey(T&nbsp;node,
                          <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                          <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Returns the key for the specified node in the expression language
 supported by an implementation. This method is called whenever a property
 key for a node has to be constructed, e.g. by the
 <a href="../../../../../org/apache/commons/configuration2/ImmutableConfiguration.html#getKeys--"><code>getKeys()</code></a> method. This implementation takes the
 given parent key, adds a property delimiter, and then adds the node's
 name.
 The name of the root node is a blank string. Note that no indices are
 returned.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#nodeKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">nodeKey</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node, for which the key must be constructed</dd>
<dd><code>parentKey</code> - the key of this node's parent (can be <b>null</b> for
        the root node)</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>this node's key</dd>
</dl>
</li>
</ul>
<a name="attributeKey-java.lang.String-java.lang.String-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>attributeKey</h4>
<pre>public&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeKey(<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                           <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;attributeName)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#attributeKey-java.lang.String-java.lang.String-">ExpressionEngine</a></code></span></div>
<div class="block">Returns the key of an attribute. The passed in <code>parentKey</code> must
 reference the parent node of the attribute. A concrete implementation
 must concatenate this parent key with the attribute name to a valid key
 for this attribute.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#attributeKey-java.lang.String-java.lang.String-">attributeKey</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>parentKey</code> - the key to the node owning this attribute</dd>
<dd><code>attributeName</code> - the name of the attribute in question</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the resulting key referencing this attribute</dd>
</dl>
</li>
</ul>
<a name="canonicalKey-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="canonicalKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>canonicalKey</h4>
<pre>public&nbsp;&lt;T&gt;&nbsp;<a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;canonicalKey(T&nbsp;node,
                               <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;parentKey,
                               <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Determines a &quot;canonical&quot; key for the specified node in the
 expression language supported by this implementation. This means that
 always a unique key if generated pointing to this specific node. For most
 concrete implementations, this means that an index is added to the node
 name to ensure that there are no ambiguities with child nodes having the
 same names. This implementation works similar to <code>nodeKey()</code>;
 however, each key returned by this method has an index (except for the
 root node). The parent key is prepended to the name of the current node
 in any case and without further checks. If it is <b>null</b>, only the
 name of the current node with its index is returned.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#canonicalKey-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">canonicalKey</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the node to be processed</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - the node, for which the key must be constructed</dd>
<dd><code>parentKey</code> - the key of this node's parent (can be <b>null</b> for
        the root node)</dd>
<dd><code>handler</code> - the <code>NodeHandler</code> for accessing the node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the canonical key of this node</dd>
</dl>
</li>
</ul>
<a name="prepareAdd-java.lang.Object-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="prepareAdd-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>prepareAdd</h4>
<pre>public&nbsp;&lt;T&gt;&nbsp;<a href="../../../../../org/apache/commons/configuration2/tree/NodeAddData.html" title="class in org.apache.commons.configuration2.tree">NodeAddData</a>&lt;T&gt;&nbsp;prepareAdd(T&nbsp;root,
                                     <a href="http://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;key,
                                     <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block"><p>
 Prepares Adding the property with the specified key.
 </p>
 <p>
 To be able to deal with the structure supported by hierarchical
 configuration implementations the passed in key is of importance,
 especially the indices it might contain. The following example should
 clarify this: Suppose the current node structure looks like the
 following:
 </p>
 <pre>
  tables
     +-- table
             +-- name = user
             +-- fields
                     +-- field
                             +-- name = uid
                     +-- field
                             +-- name = firstName
                     ...
     +-- table
             +-- name = documents
             +-- fields
                    ...
 </pre>
 <p>
 In this example a database structure is defined, e.g. all fields of the
 first table could be accessed using the key
 <code>tables.table(0).fields.field.name</code>. If now properties are
 to be added, it must be exactly specified at which position in the
 hierarchy the new property is to be inserted. So to add a new field name
 to a table it is not enough to say just
 </p>
 <pre>
 config.addProperty(&quot;tables.table.fields.field.name&quot;, &quot;newField&quot;);
 </pre>
 <p>
 The statement given above contains some ambiguity. For instance it is not
 clear, to which table the new field should be added. If this method finds
 such an ambiguity, it is resolved by following the last valid path. Here
 this would be the last table. The same is true for the <code>field</code>;
 because there are multiple fields and no explicit index is provided, a
 new <code>name</code> property would be added to the last field - which
 is probably not what was desired.
 </p>
 <p>
 To make things clear explicit indices should be provided whenever
 possible. In the example above the exact table could be specified by
 providing an index for the <code>table</code> element as in
 <code>tables.table(1).fields</code>. By specifying an index it can
 also be expressed that at a given position in the configuration tree a
 new branch should be added. In the example above we did not want to add
 an additional <code>name</code> element to the last field of the table,
 but we want a complete new <code>field</code> element. This can be
 achieved by specifying an invalid index (like -1) after the element where
 a new branch should be created. Given this our example would run:
 </p>
 <pre>
 config.addProperty(&quot;tables.table(1).fields.field(-1).name&quot;, &quot;newField&quot;);
 </pre>
 <p>
 With this notation it is possible to add new branches everywhere. We
 could for instance create a new <code>table</code> element by
 specifying
 </p>
 <pre>
 config.addProperty(&quot;tables.table(-1).fields.field.name&quot;, &quot;newField2&quot;);
 </pre>
 <p>
 (Note that because after the <code>table</code> element a new branch is
 created indices in following elements are not relevant; the branch is new
 so there cannot be any ambiguities.)
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html#prepareAdd-T-java.lang.String-org.apache.commons.configuration2.tree.NodeHandler-">prepareAdd</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/apache/commons/configuration2/tree/ExpressionEngine.html" title="interface in org.apache.commons.configuration2.tree">ExpressionEngine</a></code></dd>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the nodes to be dealt with</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>root</code> - the root node of the nodes hierarchy</dd>
<dd><code>key</code> - the key of the new property</dd>
<dd><code>handler</code> - the node handler</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a data object with information needed for the add operation</dd>
</dl>
</li>
</ul>
<a name="findNodesForKey-org.apache.commons.configuration2.tree.DefaultConfigurationKey.KeyIterator-java.lang.Object-java.util.Collection-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="findNodesForKey-org.apache.commons.configuration2.tree.DefaultConfigurationKey.KeyIterator-T-java.util.Collection-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findNodesForKey</h4>
<pre>protected&nbsp;&lt;T&gt;&nbsp;void&nbsp;findNodesForKey(<a href="../../../../../org/apache/commons/configuration2/tree/DefaultConfigurationKey.KeyIterator.html" title="class in org.apache.commons.configuration2.tree">DefaultConfigurationKey.KeyIterator</a>&nbsp;keyPart,
                                   T&nbsp;node,
                                   <a href="http://docs.oracle.com/javase/7/docs/api/java/util/Collection.html?is-external=true" title="class or interface in java.util">Collection</a>&lt;<a href="../../../../../org/apache/commons/configuration2/tree/QueryResult.html" title="class in org.apache.commons.configuration2.tree">QueryResult</a>&lt;T&gt;&gt;&nbsp;results,
                                   <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Recursive helper method for evaluating a key. This method processes all
 facets of a configuration key, traverses the tree of properties and
 fetches the results of all matching properties.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of nodes to be dealt with</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>keyPart</code> - the configuration key iterator</dd>
<dd><code>node</code> - the current node</dd>
<dd><code>results</code> - here the found results are stored</dd>
<dd><code>handler</code> - the node handler</dd>
</dl>
</li>
</ul>
<a name="findLastPathNode-org.apache.commons.configuration2.tree.DefaultConfigurationKey.KeyIterator-java.lang.Object-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a><a name="findLastPathNode-org.apache.commons.configuration2.tree.DefaultConfigurationKey.KeyIterator-T-org.apache.commons.configuration2.tree.NodeHandler-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>findLastPathNode</h4>
<pre>protected&nbsp;&lt;T&gt;&nbsp;T&nbsp;findLastPathNode(<a href="../../../../../org/apache/commons/configuration2/tree/DefaultConfigurationKey.KeyIterator.html" title="class in org.apache.commons.configuration2.tree">DefaultConfigurationKey.KeyIterator</a>&nbsp;keyIt,
                                 T&nbsp;node,
                                 <a href="../../../../../org/apache/commons/configuration2/tree/NodeHandler.html" title="interface in org.apache.commons.configuration2.tree">NodeHandler</a>&lt;T&gt;&nbsp;handler)</pre>
<div class="block">Finds the last existing node for an add operation. This method traverses
 the node tree along the specified key. The last existing node on this
 path is returned.</div>
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>T</code> - the type of the nodes to be dealt with</dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>keyIt</code> - the key iterator</dd>
<dd><code>node</code> - the current node</dd>
<dd><code>handler</code> - the node handler</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the last existing node on the given path</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/DefaultExpressionEngine.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/apache/commons/configuration2/tree/DefaultConfigurationKey.KeyIterator.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/apache/commons/configuration2/tree/DefaultExpressionEngineSymbols.html" title="class in org.apache.commons.configuration2.tree"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/apache/commons/configuration2/tree/DefaultExpressionEngine.html" target="_top">Frames</a></li>
<li><a href="DefaultExpressionEngine.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &#169; 2001&#x2013;2017 <a href="https://www.apache.org/">The Apache Software Foundation</a>. All rights reserved.</small></p>
</body>
</html>
